// ---------------------------------------------------------------------------

#include <vcl.h>
#include <System.Threading.hpp>
#include <System.Diagnostics.hpp>
#include <System.SyncObjs.hpp>
#pragma hdrstop
#include "cppMain.h"


const unsigned int KI_MAX = 50000000;


// ---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TfrmMain *frmMain;



// ---------------------------------------------------------------------------
__fastcall TfrmMain::TfrmMain(TComponent* Owner): TForm(Owner)
{
}



// ---------------------------------------------------------------------------
void __fastcall TfrmMain::butForLoopClick(TObject *Sender)
{
	unsigned int iTot = 0;


	System::Diagnostics::TStopwatch sw = System::Diagnostics::TStopwatch::Create();
	sw.Start();

	for (unsigned int iCont = 1; iCont <= KI_MAX; iCont++)
	{
		if (IsPrime(iCont))
		{
			iTot++;
		}
	}

	sw.Stop();
	mmoResults->Lines->Add(String().sprintf(L"Sequential For loop. Time (in milliseconds): %lld, Primes found: %u", sw.ElapsedMilliseconds, iTot));
}




// ---------------------------------------------------------------------------
void __fastcall TfrmMain::btnParallelForClick(TObject *Sender)
{
	miTot = 0;

	System::Diagnostics::TStopwatch sw = System::Diagnostics::TStopwatch::Create();
	sw.Start();

	TParallel::For(NULL, 1, KI_MAX, ParallelIterator);

	sw.Stop();
	mmoResults->Lines->Add (String().sprintf(L"Parallel For loop. Time (in milliseconds): %lld, Primes found: %u", sw.ElapsedMilliseconds, miTot));
}



// ---------------------------------------------------------------------------
void __fastcall TfrmMain::ParallelIterator(TObject* Sender, int AIndex)
{
	if (IsPrime(AIndex))
	{
		TInterlocked::Increment((int &) miTot);
	}
}



// ---------------------------------------------------------------------------
bool TfrmMain::IsPrime(unsigned int piN)
{
	unsigned int iTest, iSquare;
	bool bPrime;


	if (piN <= 3)
	{
		return(piN > 1);
	}
	else if (((piN & 1) == 0) || ((piN % 3) == 0))
	{
		return(false);
	}
	else
	{
		bPrime = true;
		iSquare = sqrt((double) piN);
		iTest = 5;
		while (iTest <= iSquare)
		{
			if (((piN % iTest) == 0) || ((piN % (iTest + 2)) == 0))
			{
				bPrime = false;
				break; // jump out of the for loop
			}
			iTest += 6;
		}
		return(bPrime);
	}
}
//---------------------------------------------------------------------------

